var Base64 = window.Base64;
var _ = window._;

var provide = function (apiName, timeout) {
  return function () {
    var args = _.toArray(arguments);
    var callback = args.length > 0 ? args.pop() : function () {};
    if (typeof callback !== "function") {
      args.push(callback);
      callback = function () {};
    }

    var asyncParams = {
      arguments: args,
    };

    var callbackName = "asyncCallback" + _.uniqueId();

    var timer = null;
    if (timeout !== -1) {
      timer = setTimeout(function () {
        window[callbackName] = null;

        callback("TIMEOUT");
      }, timeout);
    }
    window[callbackName] = function (b64Result) {
      if (timer) {
        clearTimeout(timer);
      }

      window[callbackName] = null;

      var ret = JSON.parse(Base64.decode(b64Result));
      callback.apply(null, ret);
    };

    asyncParams.callback = callbackName;

    _.defer(function () {
      var encodedArgs = Base64.encode(JSON.stringify(asyncParams));
      if (window.JSInterface) {
        window.JSInterface[apiName](encodedArgs);
      } else {
        var iframe = document.createElement("iframe");
        iframe.style.display = "none";
        iframe.src = "async:" + apiName + ":" + encodedArgs;
        document.body.appendChild(iframe);
        document.body.removeChild(iframe);
      }
    });
  };
};
document.addEventListener(
  "DOMContentLoaded",
  function () {
    provide("documentReady", -1)();
  },
  false
);
window.setFontSize = function (b64Str) {
  var fontSize = Base64.decode(b64Str);
  var html = document.querySelectorAll("html")[0];
  html.style.fontSize = fontSize + "px";
};

