/**
 * 页面宽度，A4纸比例高度，页数，列数
 */
var documentWidth = 750;
var a4Height = (documentWidth / 210) * 297;
var count = 0;
var column = 1;
var pageAble = false;
var fillHeight = '0'
var timer = null
var showRule = true

// A4排版
function setPage() {
  pageAble = true;
  var containerBox = document.querySelector(".paging-container-box");
  containerBox.style.padding = "40px 0";
  setColumn(column);
}
// 增加分页
function paging(containerBox) {
  containerBox.style.height = a4Height + "px";
  var container = document.querySelector(".paging-container");
  document.body.style.overflowX = 'visible';
  clearTimeout(timer);
  timer = setTimeout(function() {
    count = Math.ceil(document.body.scrollWidth / (documentWidth + 3));
    fillHeight = a4Height * ((documentWidth * count - document.body.scrollWidth) / (documentWidth/column)).toFixed()
    if (count > 1) {
      var pageInfo = createElement("page-info");
      pageInfo.innerText = "1/" + count;
      containerBox.appendChild(pageInfo);

      var html = container.innerHTML;
      var box = createElement("page-remain");
      for (var i = 1; i < count; i++) {
        appendDom(html, a4Height, i, box);
      }
      document.body.appendChild(box);
    } else {
      fillHeight = Math.floor((column * a4Height - container.scrollHeight) / a4Height) * a4Height
      var tmp = createElement("");
      tmp.style.height = fillHeight - 2 + "px";
      container.appendChild(tmp)
    }
    document.body.style.overflowX = 'hidden';
  })
}
// 增加的dom
function appendDom(html, height, index, box) {
  var div = createElement("paging-container-box");
  div.style.height = height + "px";
  div.style.padding = "40px 0";
  div.style.columnCount = column;
  div.style.webkitColumnCount = column;
  div.style.columnWidth = Math.floor(documentWidth / column) + 'px'
  div.style.webkitColumnWidth = Math.floor(documentWidth / column) + 'px'
  div.style.transform = "translateX(" + (-index * documentWidth - index * 3) + "px)";
  div.style.webkitTransform = "translateX(" + (-index * documentWidth - index * 3) + "px)";
  var inner = createElement("paging-container");
  inner.innerHTML = html;
  if (index == count - 1) {
    var tmp = createElement("");
    tmp.style.height = fillHeight - 2 + "px";
    inner.appendChild(tmp)
  }
  div.appendChild(inner);

  var pageInfo = createElement("page-info-relative");
  pageInfo.innerText = index + 1 + "/" + count;

  var splitGap = createElement("split-gap");
  box.appendChild(splitGap);
  box.appendChild(div);
  box.appendChild(pageInfo);
}
// 设置列数 分列
function setColumn(col) {
  clearPageRemain();
  column = col;
  var containerBox = document.querySelector(".paging-container-box");
  containerBox.style.columnCount = column;
  containerBox.style.webkitColumnCount = column;
  containerBox.style.columnWidth = Math.floor(documentWidth / column) + 'px'
  containerBox.style.webkitColumnWidth = Math.floor(documentWidth / column) + 'px'
  if (pageAble) {
    paging(containerBox);
  }
  setTimeout(function() {
    showColumnRule(showRule)
  })
}
// 设置字体
window.setFontSize = function(b64Str) {
  var fontSize = Base64.decode(b64Str);
    var html = document.querySelectorAll("html")[0];
    html.style.fontSize = fontSize + "px";
  if (pageAble) {
    clearPageRemain();
  }
  setTimeout(function () {
    setColumn(column);
  });
}

// 自适应
function setAdaption() {
  clearPageRemain();
  pageAble = false;
  var containerBox = document.querySelector(".paging-container-box");
  containerBox.style.columnCount = column;
  containerBox.style.webkitColumnCount = column;
  containerBox.style.height = "auto";
  containerBox.style.padding = "0";
  showColumnRule(showRule)
}
// 清除增加的dom元素
function clearPageRemain() {
  var box = document.querySelector(".page-remain");
  if (box) {
    box.remove();
  }
  var pageInfo = document.querySelector(".page-info");
  if (pageInfo) {
    pageInfo.remove();
  }
}

function createElement(className, type) {
  var dom = document.createElement(type || "div");
  dom.className = className;
  return dom;
}

window.addEventListener(
  "load",
  function () {
    documentWidth = document.body.clientWidth;
    a4Height = (documentWidth / 210) * 297 - 80;
    provide("documentReady", -1)();
    // setColumn(2)
  },
  false
);
//是否展示分列线
window.showColumnRule = function (show) {
  var width = show ? '1px' : '0px'
  showRule = show
  var containerList = document.querySelectorAll(".paging-container-box")
  for (var i = 0; i < containerList.length; i++) {
    containerList[i].style.columnRuleWidth = width
    containerList[i].style.webkitColumnRuleWidth = width
  }
}

window.resetPaging = function (b64Str, col, isA4) {
  column = col
  pageAble = isA4
  var containerBox = document.querySelector(".paging-container-box");
  if (pageAble) {
      containerBox.style.padding = "40px 0";
  } else {
      containerBox.style.padding = "0";
  }
  window.setFontSize(b64Str)
}
