"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DEMO_DATA = ["2011", "2012", "2013", "2014", "2015", "2016", "2017", "2018", "2019", "2020"];

var Picker = /*#__PURE__*/function () {
  function Picker() {
    var _this = this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Picker);

    this.wrapperContainer = options.wrapperContainer;
    this.pickerClass = options.pickerClass;
    this.mask = options.mask;
    this.coverBorder = options.coverBorder;
    this.columnItem = options.columnItem;
    this.DEFAULT_DURATION = 200;
    this.MIN_DISTANCE = 10; // 惯性滑动思路:
    // 在手指离开屏幕时，如果和上一次 move 时的间隔小于 `MOMENTUM_LIMIT_TIME` 且 move
    // 距离大于 `MOMENTUM_LIMIT_DISTANCE` 时，执行惯性滑动

    this.MOMENTUM_LIMIT_TIME = 30;
    this.MOMENTUM_LIMIT_DISTANCE = 15;
    this.supportsPassive = false; // 动画结束事件

    this.onTransitionEnd = function () {
      _this.stopMomentum();
    };

    this.onTouchMove = function (event) {
      if (_this.readonly) return;

      _this.touchMove(event);

      if (_this.direction === "vertical") {
        _this.moving = true;

        _this.preventDefault(event, true);
      }

      _this.offset = _this.range(_this.startOffset + _this.deltaY, -(_this.count * _this.itemPxHeight), _this.itemPxHeight);
      var now = Date.now();

      if (now - _this.touchStartTime > _this.MOMENTUM_LIMIT_TIME) {
        _this.touchStartTime = now;
        _this.momentumOffset = _this.offset;
      } // 滑动中


      _this.setUlTransform();
    }; // 开始滑动


    this.onTouchStart = function (event) {
      // 控制只读
      if (_this.readonly) return;
      var wrapper = document.querySelector(_this.wrapperContainer);

      _this.touchStart(event);

      if (_this.moving) {
        var translateY = _this.getElementTranslateY(wrapper);

        _this.offset = Math.min(0, translateY - _this.baseOffset);
        _this.startOffset = _this.offset;
      } else {
        _this.startOffset = _this.offset;
      }

      _this.duration = 0;
      _this.transitionEndTrigger = null;
      _this.touchStartTime = Date.now();
      _this.momentumOffset = _this.startOffset; // 设置滑动

      _this.setUlTransform();
    };

    this.onTouchEnd = function (event) {
      if (_this.readonly) return;
      var distance = _this.offset - _this.momentumOffset;

      var duration = Date.now() - _this.touchStartTime; // const allowMomentum = duration < this.MOMENTUM_LIMIT_TIME && Math.abs(distance) > this.MOMENTUM_LIMIT_DISTANCE;
      // if (allowMomentum) {
      //   this.momentum(distance, duration);
      //   return;
      // }


      var index = _this.getIndexByOffset(_this.offset);

      _this.duration = _this.DEFAULT_DURATION;

      _this.setIndex(index, true); // 滑动结束


      _this.setUlTransform(); // compatible with desktop scenario
      // use setTimeout to skip the click event triggered after touchstart


      setTimeout(function () {
        _this.moving = false;
      }, 0);
    };

    this.initValue(options);

    this._initValue(options);

    this.resetTouchStatus();
    this.initComputed(options);
    this.setEleStyle();
    this.onClickItem(options.defaultIndex || 0);
    this.setUlTransform();
    this.onMounted();
  } // 私有变量


  _createClass(Picker, [{
    key: "_initValue",
    value: function _initValue(options) {
      this.offset = 0;
      this.duration = 0;
      this.options = this.initOptions || DEMO_DATA;
      this.direction = options.direction || "vertical";
      this.deltaX = 0;
      this.deltaY = 0;
      this.offsetX = 0;
      this.offsetY = 0;
      this.startX = 0;
      this.startY = 0;
      this.moving = false;
      this.startOffset = 0;
      this.transitionEndTrigger = null; // 滚动函数

      this.touchStartTime = 0; // 记录开始滑动时间

      this.momentumOffset = 0; // 记录开始滑动位置

      this.currentIndex = this.defaultIndex;
    } // 初始化--用户变量

  }, {
    key: "initValue",
    value: function initValue(options) {
      // 可是区域子元素个数
      this.visibleItemCount = Number(options.visibleItemCount || 5) || 5; // 子元素高度

      this.itemPxHeight = Number(this.itemPxHeight) || 0.96; // 初始化传入的数据列表（当前案例微用到，可结合框架使用）

      this.initOptions = options.initOptions; // 是否只读

      this.readonly = options.readonly || false; // 初始显示元素（当前案例未使用，可结合框架扩展）

      this.defaultIndex = Number(options.defaultIndex) || 0;
    } // 根据传入变量--获取计算属性

  }, {
    key: "initComputed",
    value: function initComputed(options) {
      // 外层容器高度
      this.wrapHeight = this.itemPxHeight * this.visibleItemCount;
      this.maskStyle = {
        backgroundSize: "100% ".concat((this.wrapHeight - this.itemPxHeight) / 2, "rem")
      };
      this.frameStyle = {
        height: "".concat(this.itemPxHeight, "rem")
      }; // this.count = this.options.length

      this.count = document.querySelector(this.wrapperContainer).children.length;
      this.baseOffset = this.itemPxHeight * (this.visibleItemCount - 1) / 2; // 内层元素高度计算

      this.wrapperStyle = {
        transform: "translate3d(0, ".concat(this.offset + this.baseOffset, "rem, 0)"),
        transitionDuration: "".concat(this.duration, "ms"),
        transitionProperty: this.duration ? "all" : "none"
      };
    } // 设置外部容器的样式及遮罩层

  }, {
    key: "setEleStyle",
    value: function setEleStyle() {
      var mask = document.querySelector(this.mask);
      var coverBorder = document.querySelector(this.coverBorder);
      var columnItem = document.querySelectorAll(this.columnItem);
      mask.style.backgroundSize = this.maskStyle.backgroundSize;
      coverBorder.style.height = this.frameStyle.height;
      this.setUlStyle();
      this.setColumnHeight(columnItem);
    } // 滑动主要逻辑--动态设置容器的垂直方向偏移量

  }, {
    key: "setUlStyle",
    value: function setUlStyle() {
      var wrapperContainer = document.querySelector(this.wrapperContainer);
      wrapperContainer.style.transform = this.wrapperStyle.transform;
      wrapperContainer.style.transitionDuration = this.wrapperStyle.transitionDuration;
      wrapperContainer.style.transitionProperty = this.wrapperStyle.transitionProperty;
    }
  }, {
    key: "setUlTransform",
    value: function setUlTransform() {
      this.initComputed();
      this.setUlStyle();
    } // 设置每个行元素的高度及点击事件

  }, {
    key: "setColumnHeight",
    value: function setColumnHeight(columnItem) {
      var _this2 = this;

      Array.prototype.forEach.call(columnItem, function (item, index) {
        item.style.height = "".concat(_this2.itemPxHeight, "rem");

        item.onclick = function () {
          _this2.onClickItem(index);

          _this2.setUlTransform();
        };
      })
    } // 点击单个行元素

  }, {
    key: "onClickItem",
    value: function onClickItem(index) {
      if (this.moving || this.readonly) {
        return;
      }

      this.transitionEndTrigger = null;
      this.duration = this.DEFAULT_DURATION;
      this.setIndex(index, true);
    } // 初始化完成--执行事件绑定

  }, {
    key: "onMounted",
    value: function onMounted() {
      var el = document.querySelector(this.pickerClass);
      this.bindTouchEvent(el);
    }
  }, {
    key: "bindTouchEvent",
    value: function bindTouchEvent(el) {
      var onTouchStart = this.onTouchStart,
          onTouchMove = this.onTouchMove,
          onTouchEnd = this.onTouchEnd,
          onTransitionEnd = this.onTransitionEnd;
      var wrapper = document.querySelector(this.wrapperContainer);
      this.on(el, "touchstart", onTouchStart);
      this.on(el, "touchmove", onTouchMove);
      this.on(wrapper, "transitionend", onTransitionEnd);

      if (onTouchEnd) {
        this.on(el, "touchend", onTouchEnd);
        this.on(el, "touchcancel", onTouchEnd);
      }
    }
  }, {
    key: "on",
    value: function on(target, event, handler) {
      var passive = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      target.addEventListener(event, handler, this.supportsPassive ? {
        capture: false,
        passive: passive
      } : false);
    } // 滑动结束后数据获取及优化处理

  }, {
    key: "stopMomentum",
    value: function stopMomentum() {
      this.moving = false;
      this.duration = 0;

      if (this.transitionEndTrigger) {
        this.transitionEndTrigger();
        this.transitionEndTrigger = null;
      }
    }
  }, {
    key: "touchStart",
    value: function touchStart(event) {
      this.resetTouchStatus();
      this.startX = event.touches[0].clientX;
      this.startY = event.touches[0].clientY;
    } // 重置滑动数据变量

  }, {
    key: "resetTouchStatus",
    value: function resetTouchStatus() {
      this.direction = "";
      this.deltaX = 0;
      this.deltaY = 0;
      this.offsetX = 0;
      this.offsetY = 0;
    } // 动态获取元素滑动距离--关键

  }, {
    key: "getElementTranslateY",
    value: function getElementTranslateY(element) {
      var style = window.getComputedStyle(element);
      var transform = style.transform || style.webkitTransform;
      var translateY = transform.slice(7, transform.length - 1).split(", ")[5];
      return Number(translateY);
    } // 滑动动画函数--关键

  }, {
    key: "momentum",
    value: function momentum(distance, duration) {
      var speed = Math.abs(distance / duration);
      distance = this.offset + speed / 0.003 * (distance < 0 ? -1 : 1);
      var index = this.getIndexByOffset(distance);
      this.duration = +this.swipeDuration;
      this.setIndex(index, true);
    } // 获取当前展示的元素数据信息--关键

  }, {
    key: "setIndex",
    value: function setIndex(index, emitChange) {
      var _this3 = this;

      index = this.adjustIndex(index) || 0;
      var offset = -index * this.itemPxHeight;

      var trigger = function trigger() {
        if (index !== _this3.currentIndex) {
          _this3.currentIndex = index;

          if (emitChange) {
            // this.$emit('change', index);
            console.log(index);
          }
        }
      }; // trigger the change event after transitionend when moving


      if (this.moving && offset !== this.offset) {
        this.transitionEndTrigger = trigger;
      } else {
        trigger();
      }

      this.offset = offset;
    }
  }, {
    key: "getValue",
    value: function getValue() {
      return this.options[this.currentIndex];
    }
  }, {
    key: "adjustIndex",
    value: function adjustIndex(index) {
      index = this.range(index, 0, this.count);

      for (var i = index; i < this.count; i++) {
        if (!this.isOptionDisabled(this.options[i])) return i;
      }

      for (var _i = index - 1; _i >= 0; _i--) {
        if (!this.isOptionDisabled(this.options[_i])) return _i;
      }
    }
  }, {
    key: "isOptionDisabled",
    value: function isOptionDisabled(option) {
      return this.isObject(option) && option.disabled;
    }
  }, {
    key: "isObject",
    value: function isObject(val) {
      return val !== null && _typeof(val) === "object";
    } // 滑动偏移量

  }, {
    key: "getIndexByOffset",
    value: function getIndexByOffset(offset) {
      return this.range(Math.round(-offset / this.itemPxHeight), 0, this.count - 1);
    } // 阻止默认行为

  }, {
    key: "preventDefault",
    value: function preventDefault(event, isStopPropagation) {
      /* istanbul ignore else */
      if (typeof event.cancelable !== "boolean" || event.cancelable) {
        event.preventDefault();
      }

      if (isStopPropagation) {
        this.stopPropagation(event);
      }
    }
  }, {
    key: "stopPropagation",
    value: function stopPropagation(event) {
      event.stopPropagation();
    }
  }, {
    key: "touchMove",
    value: function touchMove(event) {
      var touch = event.touches[0];
      this.deltaX = touch.clientX - this.startX;
      this.deltaY = (touch.clientY - this.startY) / 50;
      this.offsetX = Math.abs(this.deltaX);
      this.offsetY = Math.abs(this.deltaY);
      this.direction = this.direction || this.getDirection(this.offsetX, this.offsetY);
    } // 确定滑动方向

  }, {
    key: "getDirection",
    value: function getDirection(x, y) {
      if (x > y && x > this.MIN_DISTANCE) {
        return "horizontal";
      }

      if (y > x && y > this.MIN_DISTANCE) {
        return "vertical";
      }

      return "";
    } // 滑动范围限制--关键代码

  }, {
    key: "range",
    value: function range(num, min, max) {
      return Math.min(Math.max(num, min), max);
    }
  }]);

  return Picker;
}();
